<?php

    // 自定义分类、标签、页面的URL伪静态格式，加.html后缀
    function custom_page_rules() {
        global $wp_rewrite;
        /** page页面自定义URL样式 **/
        $wp_rewrite->page_structure = $wp_rewrite->root . 'page/%pagename%.html';
        /** tag页面自定义URL样式 **/
        $wp_rewrite->extra_permastructs['post_tag']['with_front'] = '';
        $wp_rewrite->extra_permastructs['post_tag']['struct'] = $wp_rewrite->extra_permastructs['post_tag']['with_front'] . 'tag/%post_tag%.html';
        /** category页面自定义URL样式 **/
        $wp_rewrite->extra_permastructs['category']['with_front'] = 'category';
        $wp_rewrite -> extra_permastructs['category']['struct'] = $wp_rewrite->extra_permastructs['category']['with_front'].'/%category%.html';
    }
//    add_action( 'init', 'custom_page_rules' );

    // 显示站点标题
    function show_wp_title(){
        global $page, $paged;
        wp_title( '-', true, 'right' );
        // 添加网站标题.
        bloginfo( 'name' );
        // 为首页添加网站描述.
        $site_description = get_bloginfo( 'description', 'display' );
        if ( $site_description && ( is_home() || is_front_page() ) )
            echo ' - ' . $site_description;
        // 如果有必要，在标题上显示一个页面数.
        if ( $paged >= 2 || $page >= 2 )
            echo ' - ' . sprintf( '第%s页', max( $paged, $page ) );
    }

    function deel_category(){
        $tag_arr = get_the_category();
        foreach($tag_arr as $value){
            if(!empty($value)){
                echo '<a data-bear="main" href='.get_term_link($value->slug,$value->taxonomy).'>'.$value->name.'<a>';
            }
        }
    }

    // 获取根分类的id号
    function get_category_root_id($cat)
    {
        $this_category = get_category($cat); // 取得当前分类
        while($this_category->category_parent) // 若当前分类有上级分类时，循环
        {
            $this_category = get_category($this_category->category_parent); // 将当前分类设为上级分类（往上爬）
        }
        return $this_category->term_id; // 返回根分类的id号
    }

    // WordPress子分类页面使用父页面模板
    add_filter( 'category_template', function ( $template )
    {
        $term      = get_queried_object();
        $ancestors = get_ancestors( $term->term_id, 'category' );

        if ( ! empty( $ancestors ) ) {
            $ancestor = get_term( $ancestors[ 0 ] );
            $new_template = locate_template( [ 'templates/category/category-'. $ancestor->slug .'.php' ] );

            if ( '' != $new_template ) {
                return $new_template;
            }
        }

        return $template;
    }, 99 );
	
	include('usewp_code/usewp.php');
	add_filter('pre_option_link_manager_enabled', '__return_true');
	add_action('pre_get_posts', 'ws_filter_query');
	/**
	 * 移除/修改标题前的“私密”和“密码保护”
	 * https://www.wpdaxue.com/remove-change-private-protected-title-format.html
	 */
	add_filter( 'private_title_format', 'wpdaxue_private_title_format' );
	add_filter( 'protected_title_format', 'wpdaxue_private_title_format' );
	
	function wpdaxue_private_title_format( $format ) {
		return '%s';
	}
	function ws_filter_query($query)
	{
		if(is_single()) {
			return $query;
		}else{
			if (!is_admin() && $_SESSION['post_all'] != 2019) {
				$query->query_vars['post_status'] = 'publish';
			}
			return $query;
		}
	}
	
	function get_likes($post_id)
	{
		$html = '<span class="like right">';
		$html .= '<a href="#" class="sl-button titleColor sl-button-79" data-nonce="' . $_SESSION['nonce'] . '" data-post-id="' . get_the_ID() . '"   title="喜欢">';
		$user_like = get_user_meta($_SESSION['nonce'], 'like_posts', true);
		if ($user_like && in_array($post_id, $user_like)) {
			$html .= '<svg t="1546854888242" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="15168" xmlns:xlink="http://www.w3.org/1999/xlink"><path d="M924.6 125.2C815 31.8 652 48.6 551.4 152.4L512 193l-39.4-40.6C372.2 48.6 209 31.8 99.4 125.2c-125.6 107.2-132.2 299.6-19.8 415.8l387 399.6c25 25.8 65.6 25.8 90.6 0l387-399.6c112.6-116.2 106-308.6-19.6-415.8z"></path></svg>';
		} else {
			$html .= '<svg t="1546854871215" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="15052" xmlns:xlink="http://www.w3.org/1999/xlink"><path d="M916.80024 128.6C801.20024 31.4 622.60024 46 512.00024 158.6 401.40024 46 222.80024 31.2 107.20024 128.6-43.19976 255.2-21.19976 461.6 86.00024 571l350.8 357.4c20 20.4 46.8 31.8 75.2 31.8 28.6 0 55.2-11.2 75.2-31.6L938.00024 571.2c107-109.4 129.4-315.8-21.2-442.6z m-47.2 375L518.80024 861c-4.8 4.8-8.8 4.8-13.6 0L154.40024 503.6c-73-74.4-87.8-215.2 14.6-301.4 77.8-65.4 197.8-55.6 273 21l70 71.4 70-71.4c75.6-77 195.6-86.4 273-21.2 102.2 86.2 87 227.8 14.6 301.6z"></path></svg>';
		}
		$html .= '<b class="sl-count">';
		$html .= get_post_meta(get_the_ID(), 'likes', true) ?: 0;
		$html .= '</b></a><span id="sl-loader" style="display:none;"><img src="';
		$html .= get_bloginfo('template_url');
		$html .= '/static/picture/loading.gif"class="salong-ajax"/></span></span>';
		echo $html;
	}
	
	//用户不允许进入后台
	if (is_admin() && (!defined('DOING_AJAX') || !DOING_AJAX)) {
		$current_user = wp_get_current_user(); //获取当前用户的信息
		if ($current_user->roles[0] == get_option('default_role')) { //如果不是管理
			wp_safe_redirect(home_url()); //重定向到网站的首页
			exit();
		}
	}
	//隐藏ACF字段
	//add_filter('acf/settings/show_admin', '__return_false');

?>