<?php
	add_filter('use_block_editor_for_post', '__return_false');


	function down_img_to_wp11($file_url)
	{
		preg_match('/[^\?]+\.(jpg|jpe|jpeg|gif|png)/i', $file_url, $matches);
		$name = basename($matches[0]);
		$type = getimagesize($file_url);
		$save_to = wp_upload_dir()['path'] . '/' . $name;
		$save_url = wp_upload_dir()['url'] . '/' . $name;
		$content = file_get_contents($file_url);
		file_put_contents(iconv('UTF-8', 'GBK', $save_to), $content);
		$attachment = array(
			'guid' => $save_url,
			'post_mime_type' => $type['mime'],
			'post_title' => 'NO IMG',
			'post_content' => '',
			'post_status' => 'inherit'
		);
		$attach_id = wp_insert_attachment($attachment, $save_to);
		require_once(ABSPATH . 'wp-admin/includes/image.php');
		$attach_data = wp_generate_attachment_metadata($attach_id, $save_to);
		wp_update_attachment_metadata($attach_id, $attach_data);
		return $attach_id;
	}
	
	add_filter('show_admin_bar', '__return_false');
	
	function ws_comment_list($comment, $args, $depth)
	{
		echo '<li ';
		echo ' id="comment-' . get_comment_ID() . '">';
		echo '<h5>' . get_comment_author() . ' 发表于 ' . time_ago() . '</h5>';
		if ($comment->comment_approved !== '0') {
			if (is_user_logged_in()) {
				echo comment_reply_link(array_merge($args, array('add_below' => 'div-comment', 'depth' => $depth, 'max_depth' => $args['max_depth'])));
			}
			//echo edit_comment_link(__('(编辑)'),' - ','');
		}
		echo '<div class="ws_com" id="div-comment-' . get_comment_ID() . '">';
		if ($comment->comment_approved == '0') {
			echo '<span class="c-approved">您的评论正在排队审核中，系统已经发送电子邮件给管理员，请耐心等待！</span><br />';
		} else {
			echo convert_smilies(get_comment_text());
		}
		echo '</div>';
	}
	
	//时间显示方式'xx以前'
	function time_ago($type = 'commennt', $day = 7)
	{
		$d = $type == 'post' ? 'get_post_time' : 'get_comment_time';
		if (time() - $d('U') > 60 * 60 * 24 * $day) {
			return false;
		}
		return human_time_diff($d('U'), strtotime(current_time('mysql', 0))) . '前';
	}
	
	function timeago($ptime)
	{
		$ptime = strtotime($ptime);
		$etime = time() - $ptime;
		if ($etime < 1) return '刚刚';
		$interval = array(
			12 * 30 * 24 * 60 * 60 => '年前 (' . date('Y-m-d', $ptime) . ')',
			30 * 24 * 60 * 60 => '个月前 (' . date('m-d', $ptime) . ')',
			7 * 24 * 60 * 60 => '周前 (' . date('m-d', $ptime) . ')',
			24 * 60 * 60 => '天前',
			60 * 60 => '小时前',
			60 => '分钟前',
			1 => '秒前'
		);
		foreach ($interval as $secs => $str) {
			$d = $etime / $secs;
			if ($d >= 1) {
				$r = round($d);
				return $r . $str;
			}
		};
	}

?>