<?php
	
	class USEWP_AJAX
	{
		
		public function __construct()
		{
			//注册AJAX
			add_action('wp_ajax_usewp_ajax', array($this, 'usewp_ajax'));
			add_action('wp_ajax_nopriv_usewp_ajax', array($this, 'usewp_ajax'));
		}
		
		//AJAX任务分拨中心
		public function usewp_ajax()
		{
			//判断任务类型
			$usewp_action = $_POST['usewp_action'];
			//获取所有表单数据
			//开始分拨
			switch ($usewp_action) {
				case 'like':
					//如果是用户喜欢的操作
					$this->user_like($_POST['post_id'], $_POST['nonce']);
					
					break;
				case 'usewp_login':
					$this->usewp_login($_POST);
					break;
				case 'usewp_register':
					$this->usewp_register($_POST);
					break;
				case 'add_url':
					$this->add_url($_POST);
					break;
				case 'search':
					$this->search($_POST);
					break;
			}
			//结束流程，避免返回0
			exit;
		}
		
		public function search($data)
		{
			global $user_ID;
			$like_posts = get_user_meta($user_ID,'like_posts',true);
			$arg=array(
				's'=>$data['value'],
				'post_type'=>'bookmarks',
				'post__not_in'=>$like_posts
				
			);
			query_posts($arg);
			if(have_posts()){
				while(have_posts()):the_post();
					echo '<li><a >'.get_the_title().'</a><b onclick="add_url('.get_the_ID().')">添加</b></li>';
				endwhile;
			}else{
				echo '<li><a>没有找到相关内容</a></li>';
			}
		}
		public function user_like($post_id, $user_id)
		{
			if (is_user_logged_in()) {
				global $user_ID;
				$uid = $user_ID;
			} else {
				$uid = $user_id;
			}
			$post = get_post($post_id);
			$type = $post->post_type.'_like';
			$all_num = (int)get_option($type)?:0;
			//当前用户喜欢的文章列表
			$like_posts = get_user_meta($uid, 'like_posts', true);
			
			//此篇文章的喜欢总数
			$post_likes = get_post_meta($post_id, 'likes', true) ?: 0;
			$like = 'liked';
			$icon = '<svg t="1546854888242" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="15168" xmlns:xlink="http://www.w3.org/1999/xlink"><path d="M924.6 125.2C815 31.8 652 48.6 551.4 152.4L512 193l-39.4-40.6C372.2 48.6 209 31.8 99.4 125.2c-125.6 107.2-132.2 299.6-19.8 415.8l387 399.6c25 25.8 65.6 25.8 90.6 0l387-399.6c112.6-116.2 106-308.6-19.6-415.8z"></path></svg>';
			if ($like_posts) {
				//如果有值他必定是数组
				if (in_array($post_id, $like_posts)) {
					//他已经在数组里面了。说明用户已经喜欢过。再次执行，需要取消喜欢
					foreach ($like_posts as $k => $v) {
						if ($v == $post_id) {
							unset($like_posts[$k]);
						}
					}
					$post_likes = $post_likes - 1;
					$all_num = $all_num -1;
					$like = 'unliked';
					$icon = '<svg t="1546854871215" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="15052" xmlns:xlink="http://www.w3.org/1999/xlink"><path d="M916.80024 128.6C801.20024 31.4 622.60024 46 512.00024 158.6 401.40024 46 222.80024 31.2 107.20024 128.6-43.19976 255.2-21.19976 461.6 86.00024 571l350.8 357.4c20 20.4 46.8 31.8 75.2 31.8 28.6 0 55.2-11.2 75.2-31.6L938.00024 571.2c107-109.4 129.4-315.8-21.2-442.6z m-47.2 375L518.80024 861c-4.8 4.8-8.8 4.8-13.6 0L154.40024 503.6c-73-74.4-87.8-215.2 14.6-301.4 77.8-65.4 197.8-55.6 273 21l70 71.4 70-71.4c75.6-77 195.6-86.4 273-21.2 102.2 86.2 87 227.8 14.6 301.6z"></path></svg>';
				} else {
					//说明没有喜欢过。要添加
					array_push($like_posts, $post_id);
					$post_likes = $post_likes + 1;
					$all_num =$all_num+1;
				}
			} else {
				//用户是第一次点击喜欢的按钮
				$like_posts = array($post_id);
				$post_likes = $post_likes + 1;
				$all_num = $all_num+1;
			}
			update_user_meta($uid, 'like_posts', $like_posts);
			//更新文章的喜欢总数
			update_post_meta($post_id, 'likes', $post_likes);
			
			update_option($type,$all_num);
			$back = array(
				'status' => $like,
				'icon' => $icon,
				'count' => '<b class="sl-count">' . $post_likes . '</b>'
			);
			header('Content-Type:application/json; charset=utf-8');
			echo json_encode($back);
		}
		
		
		//处理用户登录
		public function usewp_login($data)
		{
			$login_data = array();
			$login_data['user_login'] = $data['login'];
			$login_data['user_password'] = $data['password'];
			$user_verify = wp_signon($login_data, false);
			if (is_wp_error($user_verify)) {
				echo "用户名或者密码错误";
			} else {
				echo 'OK';
			}
		}
		
		public function add_url($data)
		{
			global $user_ID;
			$ws_posts=array(
				'post_type'=>'bookmarks',
				'post_content'=>$data['url_content'],
				'post_title'=>$data['url_title'],
				'post_status'=>'private',
				'post_author'=>$user_ID
			);
			$post_id = wp_insert_post($ws_posts);
			if($post_id){
				set_post_thumbnail($post_id, $data['url_img']);
				update_post_meta($post_id,'language',$data['url_language']);
				$re = update_post_meta($post_id,'url',$data['url_url']);
				if($re){
					echo 'OK';
				}else{
					echo '添加失败';
				}
			}else{
				echo '添加失败';
			}
		}
		//处理用户注册
		public function usewp_register($data)
		{
			
			$email = $data['login'] . '@qq.com';
			if (email_exists($email)) {
				echo '用户名已经被注册';
			} else {
				if (username_exists($data['login'])) {
					echo '用户名已经被注册';
				} else {
					$userdata = array(
						'user_login' => $data['login'],
						'user_email' => $email,
						'user_pass' => $data['password'],
					);
					$user_id = wp_insert_user($userdata);
					if (!$user_id) {
						echo '注册失败，请联系管理员';
					} else {
						wp_set_current_user($user_id, $data['login']);
						wp_set_auth_cookie($user_id);
						do_action('wp_login', $data['ws_phone']);
						echo 'OK';
					}
				}
			}
		}
		
		//处理邮件事务
		public function usewp_email($data)
		{
			echo '邮件处理';
		}
		
	}

?>

