<?php

	class  USEWP_IMG
	{
		public function __construct()
		{
			//为文章添加特色图像
			add_theme_support('post-thumbnails');
		}

		// 获取特色图片作为第一张图片
        // 调用函数需使用echo显示图片
		public function get_post_img($width = null, $height = null, $post_id = null)
		{
			
			if ($values = get_post_custom_values("thumb", $post_id)) {
				$values = get_post_custom_values("thumb", $post_id);
				$img = $values [0];
			} elseif (get_post_thumbnail_id($post_id)) {    //如果有特色缩略图，则输出缩略图地址
				$thumbnail_src = wp_get_attachment_image_src(get_post_thumbnail_id($post_id), 'full');
				$img = $thumbnail_src [0];
			} else {
				$img = $this->get_post_first_img_src($post_id);
			}
			if (!$img) {
				$img_a = get_field('user_header','option');
				if($img_a){
					$img = $img_a;
				}else {
					//这是默认图片
					global $post;
					if($post->post_type == 'books'){
						$img = get_bloginfo('template_url') . '/static/picture/book.png';
					}elseif($post->post_type =='tools') {
						$img = get_bloginfo('template_url') . '/static/picture/tool.png';
					}else{
						$img = get_bloginfo('template_url') . '/static/picture/book-loading.png';
					}
				}
			}
			if ($width && $height) {
				return $this->the_img_size($img, $width, $height);
			} else {
				return $img;
			}

		}

		//上传图片重命名执行代码
		public function rename_img_code($file)
		{
			$time = date("YmdHis");
			$file['name'] = $time . "" . mt_rand(1, 100) . "." . pathinfo($file['name'], PATHINFO_EXTENSION);
			return $file;
		}

		//上传图片重命名
		public function rename_img()
		{
			add_filter('wp_handle_upload_prefilter', array($this, 'rename_img_code'));
		}

		//获取文中的所有图片
		public function get_post_img_only($post_id = null)
		{
			if ($post_id == null) {
				global $post;
			} else {
				$post = get_posts($post_id);
			}
			ob_start();
			ob_end_clean();
			preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches); //从文章内容中获取第一张图片
			if ($matches) {  //如果日志中有图片，则显示图片
				return $matches;
			} else {
				return false;
			}
		}

		//获取文章内容，不要图片，可以截取指定的长度
		public function get_content_noimg($num = null, $post_id = null, $more = null)
		{ //过滤文章中的图片
			if ($post_id == null) {
				global $post;
			} else {
				$post = get_posts($post_id);
			}
			ob_start();
			ob_end_clean();
			$content = preg_replace('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', '', $post->post_content);
			$content = str_replace('&nbsp;', '', $content);
			if ($content) {
				if ($num > 0) {
					return wp_trim_words($content, $num, $more);
				} else {
					return $content;
				}
			} else {
				return false;
			}
		}

		//采集图片到指定的尺寸
		public function the_img_size($url, $width, $height)
		{
			return get_bloginfo('template_url') . '/src.php?src=' . $url . '&q=90&w=' . $width . '&h=' . $height . '&c=1';
		}

		//获取文中的第一张图片
		private function get_post_first_img_src($post_id = null)
		{
			if (!$post_id) {
				global $post;
			} else {
				$post = get_post($post_id);
			}
			$first_img = '';
			ob_start();
			ob_end_clean();
			$text = $post->post_content;
			$start = stripos($text, '<img');
			$text = substr($text, $start + 1);
			$start_1 = stripos($text, '<');
			$text = substr($text, $start, $start_1 - 1);
			$text = '<' . $text . '>';
			preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $text, $matches);
			$first_img = $matches [1] [0];
			if ($first_img) {
				return $first_img;
			} else {
				//这里可以输出默认图片
				return false;
			}
		}

		//下载图片保持到本地，如果成功返回媒体库图片ID
		public function download_img($img_url)
		{
			if ($img_url) {
				$get = wp_remote_get($img_url);
				$type = wp_remote_retrieve_header($get, 'content-type');
				$file_name = date('YmdHis') . mt_rand(1000, 9999) . '.jpg';
				$file_content = wp_remote_retrieve_body($get);
				$mirror = wp_upload_bits($file_name, null, $file_content);
				$attachment = array(
					'guid' => $mirror['url'],
					'post_mime_type' => $type,
					'post_title' => preg_replace('/\.[^.]+$/', '', $file_name),
					'post_content' => '',
					'post_status' => 'inherit'
				);
				$attach_id = wp_insert_attachment($attachment, $mirror['file']);
				if ($attach_id) {
					require_once(ABSPATH . 'wp-admin/includes/image.php');
					$attach_data = wp_generate_attachment_metadata($attach_id, $mirror['file']);
					wp_update_attachment_metadata($attach_id, $attach_data);
					return $attach_id;
				} else {
					return false;
				}
			} else {
				return false;
			}
		}
	}

?>