<?php
	
	class USEWP_NAV
	{
		private $nav, $no_clear;
		
		//清理导航菜单的CALSS和ID
		public function clear_nav($no_clear = null)
		{
			if (!is_array($no_clear)) {
			    // 需要保留的class属性
				$no_clear = array('current-menu-item', 'current-menu-parent', 'menu-item-has-children');
			} else {
				array_push($no_clear, 'current-menu-item');
				array_push($no_clear, 'current-menu-parent');
			}
			$this->no_clear = $no_clear;
			add_filter('nav_menu_css_class', array($this, 'clear_code'), 100, 1);
			add_filter('nav_menu_item_id', array($this, 'clear_code'), 100, 1);
			add_filter('page_css_class', array($this, 'clear_code'), 100, 1);
		}
		
		public function clear_code($var)
		{
			return is_array($var) ? array_intersect($var, $this->no_clear) : '';
		}
		
		//注册菜单
		public function add_nav($nav)
		{
			$this->nav = $nav;
			add_action('init', array($this, 'register_nav'), 10, 2);
		}
		
		public function register_nav()
		{
			register_nav_menus($this->nav);
		}
		
		//返回顶部菜单
		public function get_nav_html($nav = null)
		{
			$nav_html = wp_nav_menu(
				array(
					'theme_location' => $nav,                   //用于在调用导航菜单时指定注册过的某一个导航菜单名，如果没有指定，则显示第一个
					'menu' => '',                               //使用导航菜单的名称调用菜单，可以是 id, slug, name (按顺序匹配的) 。
					'container' => 'div',                       //最外层容器标签名
					'container_class' => 'wrap',                //最外层容器class名
					'container_id' => '',                       //最外层容器id值
					'menu_class' => 'nav-ul',                   //ul 节点的 class 属性值。
					'menu_id' => '',                            //ul 节点的 id 属性值。
					'echo' => false,                            //确定直接显示导航菜单还是返回 HTML 片段，如果想将导航的代码作为赋值使用，可设置为false。
					'fallback_cb' => 'wp_page_menu',            //备用的导航菜单函数，用于没有在后台设置导航时调用
					'before' => '',                             //显示在导航a标签之前
					'after' => '',                              //显示在导航a标签之后
					'link_before' => '',                        //显示在导航链接名之前
					'link_after' => '',                         //显示在导航链接名之后
					'items_wrap' => '<ul class="%2$s">%3$s</ul>',//使用字符串替换修改ul的class。
					'depth' => 0,                               //显示菜单的深度, 当数值为 0 时显示所有深度的菜单。
					'walker' => new new_nav_walker()
				)
			);

//            $nav_html = str_replace('<li class="current-menu-item current-menu-parent menu-item-has-children">', '<li >', $nav_html);
//            $nav_html = str_replace('<li class="menu-item-has-children">', '<li >', $nav_html);
//            $nav_html = str_replace('<a', '<a class="nav_a"', $nav_html);
            return $nav_html;
		}
		
		//返回菜单
		public function get_link_html($nav)
		{
			$nav_html = wp_nav_menu(
				array(
					'theme_location' => $nav,//用于在调用导航菜单时指定注册过的某一个导航菜单名，如果没有指定，则显示第一个
					'menu' => '',//使用导航菜单的名称调用菜单，可以是 id, slug, name (按顺序匹配的) 。
					'container' => '',//最外层容器标签名
					'container_class' => '',//最外层容器class名
					'container_id' => '',//最外层容器id值
					'menu_class' => 'clearfix',//ul 节点的 class 属性值。
					'menu_id' => '',//ul 节点的 id 属性值。
					'echo' => false,//确定直接显示导航菜单还是返回 HTML 片段，如果想将导航的代码作为赋值使用，可设置为false。
					'fallback_cb' => 'wp_page_menu',//备用的导航菜单函数，用于没有在后台设置导航时调用
					'before' => '',//显示在导航a标签之前
					'after' => '',//显示在导航a标签之后
					'link_before' => '',//显示在导航链接名之前
					'link_after' => '',//显示在导航链接名之后
					'items_wrap' => '%3$s',//使用字符串替换修改ul的class。
					'depth' => 1,//显示菜单的深度, 当数值为 0 时显示所有深度的菜单。
					'walker' => ''
				)
			);
			$nav_html = str_replace('<li>', '', $nav_html);
			$nav_html = str_replace('<li class="current-menu-item">', '', $nav_html);
			$nav_html = str_replace('<li class="current-menu-parent">', '', $nav_html);
			$nav_html = str_replace('<a', '<a target="_blank" ', $nav_html);
			$nav_html = str_replace('</li>', '', $nav_html);
			return $nav_html;
		}
	}

	// 左侧菜单
    // 需要echo语句输出
	function get_left_html($nav = null)
	{
		$nav_html = wp_nav_menu(
			array(
				'theme_location' => $nav,//用于在调用导航菜单时指定注册过的某一个导航菜单名，如果没有指定，则显示第一个
				'menu' => '',//使用导航菜单的名称调用菜单，可以是 id, slug, name (按顺序匹配的) 。
				'container' => 'nav',//最外层容器标签名
				'container_class' => 'nav-menu navBg transition',//最外层容器class名
				'container_id' => '',//最外层容器id值
				'menu_class' => 'menu',//ul 节点的 class 属性值。
				'menu_id' => '',//ul 节点的 id 属性值。
				'echo' => false,//确定直接显示导航菜单还是返回 HTML 片段，如果想将导航的代码作为赋值使用，可设置为false。
				'fallback_cb' => 'wp_page_menu',//备用的导航菜单函数，用于没有在后台设置导航时调用
				'before' => '',//显示在导航a标签之前
				'after' => '',//显示在导航a标签之后
				'link_before' => '<span>',//显示在导航链接名之前
				'link_after' => '</span>',//显示在导航链接名之后
				'items_wrap' => '<ul class="%2$s">%3$s</ul>',//使用字符串替换修改ul的class。
				'depth' => 2,//显示菜单的深度, 当数值为 0 时显示所有深度的菜单。
				'walker' => new new_walker()
			)
		);
		return $nav_html;
	}
	
	class new_nav_walker extends Walker_Nav_Menu{

        public $tree_type = array( 'post_type', 'taxonomy', 'custom' );


        public $db_fields = array(
            'parent' => 'menu_item_parent',
            'id'     => 'db_id',
        );


        public function start_lvl( &$output, $depth = 0, $args = null ) {
            if ( isset( $args->item_spacing ) && 'discard' === $args->item_spacing ) {
                $t = '';
                $n = '';
            } else {
                $t = "\t";
                $n = "\n";
            }
            $indent = str_repeat( $t, $depth );

            // Default class.
            $classes = array( 'sub_ul' );


            $class_names = implode( ' ', apply_filters( 'nav_menu_submenu_css_class', $classes, $args, $depth ) );
            $class_names = $class_names ? ' class="' . esc_attr( $class_names ) . '" style="display: none;"' : '';

            $output .= "{$n}{$indent}<ul$class_names>{$n}";
        }


        public function end_lvl( &$output, $depth = 0, $args = null ) {
            if ( isset( $args->item_spacing ) && 'discard' === $args->item_spacing ) {
                $t = '';
                $n = '';
            } else {
                $t = "\t";
                $n = "\n";
            }
            $indent  = str_repeat( $t, $depth );
            $output .= "$indent</ul>{$n}";
        }


        public function start_el( &$output, $item, $depth = 0, $args = null, $id = 0 ) {

            if ( isset( $args->item_spacing ) && 'discard' === $args->item_spacing ) {
                $t = '';
                $n = '';
            } else {
                $t = "\t";
                $n = "\n";
            }
            $indent = ( $depth ) ? str_repeat( $t, $depth ) : '';

            $classes   = empty( $item->classes ) ? array() : (array) $item->classes;
            $classes[] = 'menu-item-' . $item->ID;


            $args = apply_filters( 'nav_menu_item_args', $args, $item, $depth );


            $class_names = implode( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item, $args, $depth ) );
            $class_names = $class_names ? ' class="' . esc_attr( $class_names ) . '"' : '';


            $id = apply_filters( 'nav_menu_item_id', 'menu-item-' . $item->ID, $item, $args, $depth );
            $id = $id ? ' id="' . esc_attr( $id ) . '"' : '';

//            $output .= $indent . '<li' . $id . $class_names . '>';
            $output .= $indent . '<li>';

            $atts           = array();
            $atts['title']  = ! empty( $item->attr_title ) ? $item->attr_title : '';
            $atts['target'] = ! empty( $item->target ) ? $item->target : '';
            if ( '_blank' === $item->target && empty( $item->xfn ) ) {
                $atts['rel'] = 'noopener';
            } else {
                $atts['rel'] = $item->xfn;
            }
            $atts['href']         = ! empty( $item->url ) ? $item->url : '';
            $atts['aria-current'] = $item->current ? 'page' : '';

            $atts = apply_filters( 'nav_menu_link_attributes', $atts, $item, $args, $depth );

            $attributes = '';
            foreach ( $atts as $attr => $value ) {
                if ( is_scalar( $value ) && '' !== $value && false !== $value ) {
                    $value       = ( 'href' === $attr ) ? esc_url( $value ) : esc_attr( $value );
                    $attributes .= ' ' . $attr . '="' . $value . '"';
                }
            }

            /** This filter is documented in wp-includes/post-template.php */
            $title = apply_filters( 'the_title', $item->title, $item->ID );


            $title = apply_filters( 'nav_menu_item_title', $title, $item, $args, $depth );

            $item_output  = $args->before;

            $item_output .= '<a' . $attributes . ' class="nav_a';
            if ($depth != 0) {
                $item_output .= $depth+1 .'">';
            } else {
                $item_output .= '">';
            }


            $item_output .= $args->link_before . $title . $args->link_after;
            $item_output .= '</a>';
            $item_output .= $args->after;


            $output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args );
        }


        public function end_el( &$output, $item, $depth = 0, $args = null ) {
            if ( isset( $args->item_spacing ) && 'discard' === $args->item_spacing ) {
                $t = '';
                $n = '';
            } else {
                $t = "\t";
                $n = "\n";
            }
            $output .= "</li>{$n}";
        }
    }

	class new_walker extends Walker_Nav_Menu
	{
		public function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 ) {
			if ( isset( $args->item_spacing ) && 'discard' === $args->item_spacing ) {
				$t = '';
				$n = '';
			} else {
				$t = "\t";
				$n = "\n";
			}
			$indent = ( $depth ) ? str_repeat( $t, $depth ) : '';
			$classes   = empty( $item->classes ) ? array() : (array) $item->classes;
			$classes[] = 'menu-item-' . $item->ID;
			$args = apply_filters( 'nav_menu_item_args', $args, $item, $depth );
			$class_names = join( ' ', apply_filters( 'nav_menu_css_class', array_filter( $classes ), $item, $args, $depth ) );
			$class_names = $class_names ? ' class="' . esc_attr( $class_names ) . '"' : '';
			$id = apply_filters( 'nav_menu_item_id', 'menu-item-' . $item->ID, $item, $args, $depth );
			$id = $id ? ' id="' . esc_attr( $id ) . '"' : '';
			$output .= $indent . '<li' . $id . $class_names . '>';
			$atts           = array();
			$atts['title']  = ! empty( $item->attr_title ) ? $item->attr_title : '';
			$atts['target'] = ! empty( $item->target ) ? $item->target : '';
			if ( '_blank' === $item->target && empty( $item->xfn ) ) {
				$atts['rel'] = 'noopener noreferrer';
			} else {
				$atts['rel'] = $item->xfn;
			}
			$atts['href']         = ! empty( $item->url ) ? $item->url : '';
			$atts['aria-current'] = $item->current ? 'page' : '';
			$atts = apply_filters( 'nav_menu_link_attributes', $atts, $item, $args, $depth );
			$attributes = '';
			foreach ( $atts as $attr => $value ) {
				if ( ! empty( $value ) ) {
					$value       = ( 'href' === $attr ) ? esc_url( $value ) : esc_attr( $value );
					$attributes .= ' ' . $attr . '="' . $value . '"';
				}
			}
			$title = apply_filters( 'the_title', $item->title, $item->ID );
			$title = apply_filters( 'nav_menu_item_title', $title, $item, $args, $depth );
			$item_output  = $args->before;
			$item_output .= '<a' . $attributes . '>';

			if($item->description) {
				$item_output .= '<img src="' . $item->description . '" class="left_nav"/>';
			}
			$item_output .= $args->link_before . $title . $args->link_after;
			$item_output .= '</a>';
			$item_output .= $args->after;
			$output .= apply_filters( 'walker_nav_menu_start_el', $item_output, $item, $depth, $args );
		}
	}

?>