<?php

	class USEWP
	{

	    // 获取分类下文章数量
        function get_category_count($input = '') {
            global $wpdb;

            if($input == '') {
                $category = get_the_category();
                return $category[0]->category_count;
            }
            elseif(is_numeric($input)) {
                $SQL = "SELECT $wpdb->term_taxonomy.count FROM $wpdb->terms, $wpdb->term_taxonomy WHERE $wpdb->terms.term_id=$wpdb->term_taxonomy.term_id AND $wpdb->term_taxonomy.term_id=$input";
                return $wpdb->get_var($SQL);
            }
            else {
                $SQL = "SELECT $wpdb->term_taxonomy.count FROM $wpdb->terms, $wpdb->term_taxonomy WHERE $wpdb->terms.term_id=$wpdb->term_taxonomy.term_id AND $wpdb->terms.slug='$input'";
                return $wpdb->get_var($SQL);
            }
        }

	    // 产生随机颜色
        // 返回：随机6位十六进制数字，需要前面加 “#”组成随机十六进制颜色。
        function get_random_color()
        {
            mt_srand((double)microtime()*1000000);
            $c = '';
            while(strlen($c)<6){
                $c .= sprintf("%02X", mt_rand(0, 255));
            }
            return $c;
        }

        // 获取浏览量
        // 调用函数需使用echo显示输出。
		public function get_views($post_id = null, $num = 1)
		{
			global $post;
			if (!$post_id) {
				$post_id = $post->ID;
			}
			$views = get_post_meta($post_id, 'views', true) ?: 1;
			if ($post_id && (is_single() || is_page())) {
				update_post_meta($post_id, 'views', $views + $num);
				$type = $post->post_type.'_view';
				$all_num = get_option($type)?:0;
				update_option($type,(int)$all_num+1);
			}
			return $views;
		}

		public function is_wechat()
		{
			if (strpos($_SERVER['HTTP_USER_AGENT'],
					'MicroMessenger') !== false) {
				return true;
			}
			return false;
		}

		// category 分页
		public function get_pages()
		{
			$p =2;
			global $wp_query,$paged;
			$max_page = $wp_query->max_num_pages;       // 最大页数
			if ($max_page > 1) {
				if (empty($paged)) {
					$paged = 1;
				}
				echo '<div class="diy_page" style="text-align: center;"';
				if ($paged > $p + 2) {
					echo ' <div><a ><input type="text" placeholder="..."/></a> </div>';
				}
				for ($i = $paged - $p; $i <= $paged + $p; $i++) {
					if ($i > 0 && $i <= $max_page) {
						if($i == $paged){
							$this->get_page_link($i,'class="p_n"');
						}else{
							$this->get_page_link($i);
						}
					}
				}
				if ($paged < $max_page - $p - 1) {
					$this->get_page_link($max_page, '');
				}
				echo '</div>';
			}
		}

		private function get_page_link($i, $class=null,$title = '')
		{
			if ($title == '') {
				$title = "第 {$i} 页";
			}
			echo ' <a href="'.esc_html(get_pagenum_link($i)).'" '.$class.'>'.$i.'</a> '.PHP_EOL;
//            echo ' <a href="'.esc_html(get_pagenum_link($i)).'" '.$class.'>下一页</a> '.PHP_EOL;
		}

        /**
         * 数字分页函数
         * 因为wordpress默认仅仅提供简单分页
         * 所以要实现数字分页，需要自定义函数
         * @Param int $range            数字分页的宽度
         * @Return string|empty        输出分页的HTML代码
         */
        public function lingfeng_pagenavi( $range = 4 ) {
            global $paged,$wp_query;
            // max_page 是最大页数
            if ( !$max_page ) {
                $max_page = $wp_query->max_num_pages;
            }
            if( $max_page >1 ) {
                echo "<div class='diy_page' style='text-align: center;'>";
                if( !$paged ){
                    $paged = 1;         // $paged 当前页数
                }
//                echo "首页&nbsp;&nbsp;&nbsp;上一页&nbsp;";
//                if( $paged != 1 ) {
//                    echo "<a href='".get_pagenum_link(1) ."' class='extend'>首页</a>";
//                }
                echo "首页&nbsp;&nbsp;&nbsp;";
                if ($paged == 1) {
                    echo '上一页';
                }
                previous_posts_link('上一页'); // 若没有上一页则不显示
                echo "&nbsp;";

                if ( $max_page >$range ) {
                    if( $paged <$range ) {
                        for( $i = 1; $i <= ($range +1); $i++ ) {
//                            echo "<a href='".get_pagenum_link($i) ."'";
//                            if($i==$paged) echo " class='p_n'";echo ">$i</a>";
                        }
                    }elseif($paged >= ($max_page -ceil(($range/2)))){
                        for($i = $max_page -$range;$i <= $max_page;$i++){
//                            echo "<a href='".get_pagenum_link($i) ."'";
//                            if($i==$paged)echo " class='p_n'";echo ">$i</a>";
                        }
                    }elseif($paged >= $range &&$paged <($max_page -ceil(($range/2)))){
//                        for($i = ($paged -ceil($range/2));$i <= ($paged +ceil(($range/2)));$i++){
//                            echo "<a href='".get_pagenum_link($i) ."'";if($i==$paged) echo " class='p_n'";echo ">$i</a>";
//                        }
                    }
                }else{
                    // 显示 上一页 下一页之间的页码
                    for($i = 1;$i <= $max_page;$i++){
//                        echo "<a href='".get_pagenum_link($i) ."'";
//                        if($i==$paged)echo " class='p_n'";echo ">$i</a>";
                    }
                }

                if ($paged == $max_page) {
                    echo '下一页';
                }
                next_posts_link('下一页');     // 若没有下一页则不显示
                echo "&nbsp;";

                echo "<a href='".get_pagenum_link($max_page) ."' class='p_n'>尾页</a>";
                echo "&nbsp;&ensp;";

//                echo '<span>共['.$max_page.']页</span>';
                echo '第<span style="color:#F00">'.$paged.'/'. $max_page .'</span>页, ';

                // 获取分类下文章数量
                global $wp_query;
                $cat_ID = get_query_var('cat');
                $count = get_category($cat_ID)->count;
//                echo $count;
                echo '共<span style="color:#F00">' . $count .'</span>条信息';

                echo "</div>\n";
            }
        }
	}

?>