<?php

	class USEWP_SEO
	{
		protected $usewp_seo_type;

		public function __construct($usewp_seo_type)
		{
		    // 先将头部做下清理
			$this->usewp_seo_type = $usewp_seo_type;
			remove_action('wp_head', 'index_rel_link');//当前文章的索引
			remove_action('wp_head', 'feed_links_extra', 3);// 额外的feed,例如category, tag页
			remove_action('wp_head', 'start_post_rel_link', 10);// 开始篇
			remove_action('wp_head', 'parent_post_rel_link', 10);// 父篇
			remove_action('wp_head', 'adjacent_posts_rel_link', 10); // 上、下篇.
			remove_action('wp_head', 'adjacent_posts_rel_link_wp_head', 10);//rel=pre
			remove_action('wp_head', 'wp_shortlink_wp_head', 10);//rel=shortlink
			remove_action('wp_head', 'rel_canonical');
			wp_deregister_script('l10n');
			remove_action('wp_head', 'rsd_link');//移除head中的rel="EditURI"
			remove_action('wp_head', 'wlwmanifest_link');//移除head中的rel="wlwmanifest"
			remove_filter('the_content', 'wptexturize');//禁用半角符号自动转换为全角
			remove_action('wp_head', 'print_emoji_detection_script', 7);
			remove_action('wp_print_styles', 'print_emoji_styles');
			remove_action('wp_head', 'wp_generator', 10);
			remove_action('wp_head', 'feed_links', 2);
			remove_action('wp_head', 'rest_output_link_wp_head', 10);
			remove_action('wp_head', 'wp_oembed_add_discovery_links', 10);
			remove_action('wp_head', 'wp_resource_hints', 2);
			//禁用REST API功能代码
			add_filter('rest_enabled', '__return_false');
			add_filter('rest_jsonp_enabled', '__return_false');
			if (function_exists('get_field')) {
				add_action('wp_head', array($this, 'add_seo_all'), 1, 1);
				$this->add_input();
			}
		}

		public function add_seo_all()
		{
			echo '<title>' . $this->usewp_get_title() . '</title>' . PHP_EOL;
			echo '<meta name="keywords" content="' . $this->usewp_get_description() . '">' . PHP_EOL;
			echo '<meta name="description" content="' . $this->usewp_get_keywords() . '">' . PHP_EOL;
		}

		public function add_input()
		{
			if (function_exists('acf_add_local_field_group')):

				//自动获取文字类型，都添加SEO设置
				$post_type = array(
					array(
						array(
							'param' => 'taxonomy',
							'operator' => '==',
							'value' => 'all',
						),
					),
				);
				foreach ($this->usewp_seo_type as $v) {
					$re = array(
						'param' => 'post_type',
						'operator' => '==',
						'value' => $v,
					);
					array_push($post_type, array($re));
				}
				acf_add_local_field_group(array(
					'key' => 'group_5b4e9251bc2c4',
					'title' => 'SEO字段',
					'fields' => array(
						array(
							'key' => 'field_5b4e9265124c8',
							'label' => '网页标题',
							'name' => 'usewp_title',
							'type' => 'text',
							'instructions' => '',
							'required' => 0,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'default_value' => '',
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'maxlength' => '',
						),
						array(
							'key' => 'field_5b4e9272124c9',
							'label' => '关键词',
							'name' => 'usewp_keywords',
							'type' => 'text',
							'instructions' => '',
							'required' => 0,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'default_value' => '',
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'maxlength' => '',
						),
						array(
							'key' => 'field_5b4e9281124ca',
							'label' => '网页描述',
							'name' => 'usewp_description',
							'type' => 'text',
							'instructions' => '',
							'required' => 0,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'default_value' => '',
							'placeholder' => '',
							'prepend' => '',
							'append' => '',
							'maxlength' => '',
						),
					),
					'location' => $post_type,
					'menu_order' => 0,
					'position' => 'normal',
					'style' => 'default',
					'label_placement' => 'left',
					'instruction_placement' => 'label',
					'hide_on_screen' => '',
					'active' => 1,
					'description' => '',
				));

			endif;
		}

		// 自动设置并显示全站seo标题
		public function usewp_get_title($paged = null)
		{
			if(get_field('usewp_title', 'option') ) {
				$title = ' - ' . get_field('usewp_title', 'option') ?: get_bloginfo('name');
			}else{
				$title = '';
			}
			global $paged;
			if (is_home()) {
				global $usewp_url;
				$url  = get_query_var('usewp');
				if(array_key_exists($url,$usewp_url)){
					return $usewp_url[$url]['name'].$title;
				}
				if ($paged) {
					$usewp_page = '- 第' . $paged . '页';
				}
				if (get_field('usewp_title', 'option')) {
					return get_field('usewp_title', 'option') . $usewp_page;
				} else {
					return get_bloginfo('name') . $usewp_page;
				}
			} elseif (is_archive()) {
				$term = get_queried_object();
				if (get_field('usewp_title', $term)) {
					return get_field('usewp_title', $term) . $title;
				} else {
					return str_replace(' ', '', wp_title('', false)) . $title;
				}
			} else {

				if (get_field('usewp_title')) {
					return get_field('usewp_title') . $title;
				} else {
					return str_replace(' ', '', wp_title('', false)) . $title;
				}
			}
		}

        // 自动设置并显示全站seo描述
		public function usewp_get_description()
		{
			if (is_home()) {
				global $usewp_url;
				$url  = get_query_var('usewp');
				if(array_key_exists($url,$usewp_url)){
					return $usewp_url[$url];
				}
				if (get_field('usewp_description', 'option')) {
					return get_field('usewp_description', 'option');
				} else {
					return get_bloginfo('description');
				}
			} elseif (is_archive()) {
				$term = get_queried_object();
				if (get_field('usewp_description', $term)) {
					return get_field('usewp_description', $term);
				} else {
					return str_replace(' ', '', wp_title('', false));
				}
			} else {
				if (get_field('usewp_description')) {
					return get_field('usewp_description');
				} else {
					return str_replace(' ', '', wp_title('', false));
				}
			}
		}

        // 自动设置并显示全站seo关键词
		public function usewp_get_keywords()
		{
			if (is_home()) {
				global $usewp_url;
				$url  = get_query_var('usewp');
				if(array_key_exists($url,$usewp_url)){
					return $usewp_url[$url];
				}
				if (get_field('usewp_keywords', 'option')) {
					return get_field('usewp_keywords', 'option');
				} else {
					return get_bloginfo('description');
				}
			} elseif (is_archive()) {
				$term = get_queried_object();
				if (get_field('usewp_keywords', $term)) {
					return get_field('usewp_keywords', $term);
				} else {
					return str_replace(' ', '', wp_title('', false));
				}
			} else {
				if (get_field('usewp_keywords')) {
					return get_field('usewp_keywords');
				} else {
					return str_replace(' ', '', wp_title('', false));
				}
			}
		}
	}

?>